/*-------------------------------------------------------------------
Chessboard.c
(c) 2002
Lukas Babicek
xbabice1@fi.muni.cz

Obsahuje funkce pro praci s sachovnici
-------------------------------------------------------------------*/

#include "Chessboard.h"

//globalni promenne

//chessboard - toto je pole 12*12 ktere predstavuje 
//sachovnici, nad kterou se provadeji veskere operace
//4 okrajove radky a sloupce tvori "nelegalni policka" - pro lepsi
//testovani v generatoru tahu (ze figura je mimo sachovnici)
TChessboard chessboard;

//funkce

/*-------------------------------------------------------------------
void InitChessboard(void)

Nainicializuje sachovnici do stavu odpovidajicimu zacatku hry
-------------------------------------------------------------------*/

void InitChessboard(void)
{
	int i,j;


  //nejprve vsechna policka oznacime za prazdna
	for (i=2; i<10; i++)
		for (j=2;j<10; j++) 
			chessboard[i+j*12]=EMPTY;

	//okrajova policka naplnime hodnotou ILLEGAL
	for (i=0; i<12; i++){
		chessboard[i]=ILLEGAL;   
		chessboard[i+12]=ILLEGAL;
		chessboard[i+10*12]=ILLEGAL;
		chessboard[i+11*12]=ILLEGAL;
		chessboard[i*12]=ILLEGAL;
		chessboard[1+i*12]=ILLEGAL;
		chessboard[10+ i*12]=ILLEGAL;
		chessboard[11+ i*12]=ILLEGAL;
	}

	//nastavime pesce
	for (i=2;i<10;i++){
    chessboard[i+3*12]=BLACK_PAWN;
    chessboard[i+8*12]=WHITE_PAWN;
  }

	//nastavime ostatni figurky
  chessboard[26] = BLACK_ROOK;
	chessboard[27] = BLACK_KNIGHT;
	chessboard[28] = BLACK_BISHOP;
	chessboard[29] = BLACK_QUEEN;
	chessboard[30] = BLACK_KING;
  chessboard[31] = BLACK_BISHOP;
	chessboard[32] = BLACK_KNIGHT;
	chessboard[33] = BLACK_ROOK;

  chessboard[110] = WHITE_ROOK;
  chessboard[111] = WHITE_KNIGHT;
  chessboard[112] = WHITE_BISHOP;
  chessboard[113] = WHITE_QUEEN;
  chessboard[114] = WHITE_KING;
  chessboard[115] = WHITE_BISHOP;
  chessboard[116] = WHITE_KNIGHT;
  chessboard[117] = WHITE_ROOK;
}