/*-------------------------------------------------------------------
Chessboard.h
(c) 2002
Lukas Babicek
xbabice1@fi.muni.cz

Obsahuje funkce pro praci s sachovnici
-----------------------------------------------------------------*/

#ifndef __CHESSBOARD_H__
#define __CHESSBOARD_H__

//definice konstant

#define WHITE 1    //nasobic pro bile figurky
#define BLACK -1   //nasobic pro cerne figurky

#define PAWN 1
#define KNIGHT  2
#define BISHOP  3
#define ROOK  4
#define QUEEN  5
#define KING  6
#define ROOKING 7 //pro osetreni castlingu - vez, ktera nesmi byt v sachu
#define EMPTY 0
#define ILLEGAL 10    

#define WHITE_PAWN PAWN*WHITE
#define WHITE_KNIGHT KNIGHT*WHITE
#define WHITE_BISHOP BISHOP*WHITE
#define WHITE_ROOK ROOK*WHITE
#define WHITE_ROOKING ROOKING*WHITE
#define WHITE_QUEEN QUEEN*WHITE
#define WHITE_KING KING*WHITE

#define BLACK_PAWN PAWN*BLACK
#define BLACK_KNIGHT KNIGHT*BLACK
#define BLACK_BISHOP BISHOP*BLACK
#define BLACK_ROOK ROOK*BLACK
#define BLACK_ROOKING ROOKING*BLACK
#define BLACK_QUEEN QUEEN*BLACK
#define BLACK_KING KING*BLACK

//TSquare - jedno policko sachovnice
//je predstavovano cislem, ktere reprezentuje figurku na policku
typedef short TSquare;

//TChessboard - reprezentuje sachovnici
typedef TSquare TChessboard[144];

//exportovane promenne
extern TChessboard chessboard;

//protottpy funkci
void InitChessboard(void);

#endif