/*-------------------------------------------------------------------
Game.c
(c) 2002
Lukas Babicek
xbabice1@fi.muni.cz

Obsahuje funkce pro zacatek, konec hry, ovladani hracu,...
-------------------------------------------------------------------*/

#include "Game.h"
#include "Moves.h"
#include "Evaluator.h"
#include "Chessboard.h"
#include "Search.h"
#include "Winmanip.h"

//globalni promenne

short white_player = PLAYER_HUMAN;   //kdo tahne za bileho
short black_player = PLAYER_COMPUTER;//kdo tahne za cerneho

short black_death_pieces[16]; //vyhozene figurky cerneho hrace
short white_death_pieces[16]; //vyhozene figurky bileho hrace 
short black_death_number; //pocet vyhozenych cerneho
short white_death_number; //pocet vyhozenych bileho

short end = 0;  //znaci, zda doslo ke konci hry
                //1 .. sach mat
                //2 .. pat

/*-------------------------------------------------------------------
void InitGame(void)

provede vse potrebne pro inicializaci nove hry
-------------------------------------------------------------------*/

void InitGame(void)
{
  InitChessboard();
	InitEvaluator();
	InitMoves();
  black_death_number =  0;
	white_death_number = 0;
	SetStatusText("Na tahu je bily.");
	onmove = WHITE;
	end = 0;
}


//pokud za cerneho hraje pocitac, tak se provede tah
void DoBlackMove(void) 

{

  if (onmove == BLACK){


		nowonmove = onmove;
    bestmove.from = 0;  //to znaci, ze je tah neplatny
    FindBestMove(HLOUBKA, ALPHABETA_MIN_VALUE, ALPHABETA_MAX_VALUE);
    ApplyMove(&bestmove);
		nowonmove = BLACK;
		ClearExtraKings();  //vycistime pripadne extra krale pridane po rosade
		onmove = WHITE;
  	SetStatusText("Na tahu je bily.");
		if (bestmove.what != EMPTY)
			KillWhitePiece(bestmove.what);
  }

}

//pokud za bileho hraje pocitac, tak se provede tah
void DoWhiteMove(void) 
{

  if (onmove == WHITE){

		nowonmove = onmove;

    bestmove.from = 0;  //to znaci, ze je tah neplatny
    FindBestMove(HLOUBKA, ALPHABETA_MIN_VALUE, ALPHABETA_MAX_VALUE);

    ApplyMove(&bestmove);
		nowonmove = WHITE;
		ClearExtraKings();  //vycistime pripadne extra krale pridane po rosade
		onmove = BLACK;
  	SetStatusText("Na tahu je cerny.");
		if (bestmove.what != EMPTY)
			KillBlackPiece(bestmove.what);

  }
}

//vyhozeni bile figurky - pouze pridani polozky do pole
void KillWhitePiece(short what) 
{
  white_death_pieces[white_death_number] = what;
	white_death_number++;
	glutSetWindow(main_window);
	glutPostRedisplay();
}

//vyhozeni cerne figurky - pouze pridani polozky do pole
void KillBlackPiece(short what) 
{
  black_death_pieces[black_death_number] = what;
	black_death_number++;
	glutSetWindow(main_window);
	glutPostRedisplay();
}


