/*-------------------------------------------------------------------
Graphics.h
(c) 2002
Lukas Babicek
xbabice1@fi.muni.cz
-------------------------------------------------------------------*/


#ifndef __GRAPHICS_H__
#define __GRAPHICS_H__

#define GLUT_DISABLE_ATEXIT_HACK

#include"glut.h"

//konstanty

#define PIECE_BORDER_LINE_WIDTH 1.5  //sirka cary obtahujici figurky
#define BOARD_BORDER_LINE_WIDTH 2.0  //sirka cary obtahujici sachovnici
#define BOARD_GAP 20.0               //sirka mezery urcene pro popis policek sachovnice


#define DEFAULT_COLOR_BLACK_PIECE {0.5,0.3,0.0} //barva vnitrku cerne figurky
#define DEFAULT_COLOR_WHITE_PIECE {1.0,1.0,0.0} //barva vnitrku bile figurky
#define DEFAULT_COLOR_BLACK_BORDER {0.5,0.0,0.0}//barva okraje cerne figurky
#define DEFAULT_COLOR_WHITE_BORDER {0.5,0.5,0.5}//barva okraje bile figurky
#define DEFAULT_COLOR_BLACK_FIELD {0.0,0.0,0.0} //barva cerneho pole sachovnice
#define DEFAULT_COLOR_WHITE_FIELD {1.0,1.0,1.0} //barva bileho pole sachovnice
#define DEFAULT_COLOR_BOARD_BORDER {.5,.5,0.5}  //barva cary obtahujici sachovnici
#define DEFAULT_COLOR_BOARD_TEXT {1.,1.,1.}     //barva popisku sachovnice

#define DEFAULT_FONT GLUT_BITMAP_HELVETICA_12 //font pouzity pro vypis textu
//funkce

void DrawChessboard(double win_width);
void DrawPawn(GLfloat x,GLfloat y, GLfloat dx, int color);
void DrawRook(GLfloat x,GLfloat y, GLfloat dx, int color);
void DrawBishop(GLfloat x,GLfloat y, GLfloat dx, int color);
void DrawKnight(GLfloat x,GLfloat y, GLfloat dx, int color);
void DrawKing(GLfloat x,GLfloat y, GLfloat dx, int color);
void DrawQueen(GLfloat x,GLfloat y, GLfloat dx, int color);
void SetColor(int what, double r, double g, double b);
#endif