/*-------------------------------------------------------------------
Moves.h
(c) 2002
Lukas Babicek
xbabice1@fi.muni.cz

Obsahuje funkce pro generovani tahu
-----------------------------------------------------------------*/

#ifndef __MOVES_H__
#define __MOVES_H__

//konstanty

//druhy tahu:
#define MOVE_ORDINARY 0
#define MOVE_CAPTURE 1
#define MOVE_EN_PASSANT 2
#define MOVE_WHITE_CASTLING_QUEENSIDE 3
#define MOVE_WHITE_CASTLING_KINGSIDE 4
#define MOVE_BLACK_CASTLING_QUEENSIDE 5
#define MOVE_BLACK_CASTLING_KINGSIDE 6
#define MOVE_CHECKMATE 7
#define MOVE_STEALMATE 8
#define MOVE_PROMOTION_KNIGHT 9
#define MOVE_PROMOTION_BISHOP 10
#define MOVE_PROMOTION_ROOK 11
#define MOVE_PROMOTION_QUEEN 12

//flagy pro tah
#define FLAG_NORMAL 0
#define FLAG_WHITE_CASTLING_KINGSIDE 2
#define FLAG_WHITE_CASTLING_QUEENSIDE 4
#define FLAG_BLACK_CASTLING_KINGSIDE 8
#define FLAG_BLACK_CASTLING_QUEENSIDE 16

//ostatni
#define KING_CHECKED -1  //to vrati GenerateMoves pokud nekdo muze
                         //vzit nepratelskeho krale

//definice typu

//TMove - struktura definujici jeden tah
typedef struct tmove{
	short from;   //zdrojove policko
	short to;     //cilove policko
	short type;   //druh tahu (viz nahore - druhy tahu)
	short what;   //jestli sme neco tim tahem vyhodili - ulozi se to sem
  unsigned short flag;   //pouziva se pro detekci zruseni rosady
	              //0 .. tah nezrusil nic
	              //2 .. tah zrusil white_castling_kingside
								//4 .. tah zrusil white_castling_queenside
								//8 .. tah zrusil black_castling_kingside
					      //16 .. tah zrusil black_castling_queenside
  int eval;     //hodnota(ohodnoceni) tohoto tahu

	struct tmove *next;  //ukazatel na dalsi tah
} TMove, *PTMove;


//exportovane promenne

extern TMove bestmove;
extern PTMove start_move;
extern PTMove last_move;
extern short white_castling_kingside;
extern short black_castling_kingside;
extern short white_castling_queenside;
extern short black_castling_queenside;
extern short white_has_castled;
extern short black_has_castled;

//funkce
void InitMoves(void);
int GenerateMoves(void);
int GenerateQuiesenceMoves(void);
int ControlMove(short from, short to);
void ApplyMove(PTMove move);
void UndoMove(PTMove move);
void CheckEnding(void);
void ClearExtraKings(void);

#endif
